=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2012-02-01 17:02:56 +0000
+++ bzrlib/config.py	2012-02-15 22:43:50 +0000
@@ -1482,6 +1482,8 @@
         value = self._get_explicit_nickname()
         if value is not None:
             return value
+        if self.branch.name:
+            return self.branch.name
         return urlutils.unescape(self.branch.base.split('/')[-2])
 
     def has_explicit_nickname(self):

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2012-01-27 13:33:53 +0000
+++ bzrlib/tests/__init__.py	2012-02-15 22:43:50 +0000
@@ -2658,10 +2658,11 @@
         self.test_home_dir = self.test_dir + "/MemoryTransportMissingHomeDir"
         self.permit_dir(self.test_dir)
 
-    def make_branch(self, relpath, format=None):
+    def make_branch(self, relpath, format=None, name=None):
         """Create a branch on the transport at relpath."""
         repo = self.make_repository(relpath, format=format)
-        return repo.bzrdir.create_branch(append_revisions_only=False)
+        return repo.bzrdir.create_branch(append_revisions_only=False,
+                                         name=name)
 
     def get_default_format(self):
         return 'default'

=== modified file 'bzrlib/tests/test_config.py'
--- bzrlib/tests/test_config.py	2012-02-01 17:02:56 +0000
+++ bzrlib/tests/test_config.py	2012-02-15 22:43:50 +0000
@@ -1196,6 +1196,10 @@
         b = self.make_branch('!repo')
         self.assertEqual('!repo', b.get_config().get_nickname())
 
+    def test_autonick_uses_branch_name(self):
+        b = self.make_branch('foo', name='bar')
+        self.assertEqual('bar', b.get_config().get_nickname())
+
     def test_warn_if_masked(self):
         warnings = []
         def warning(*args):

=== modified file 'doc/en/release-notes/bzr-2.5.txt'
--- doc/en/release-notes/bzr-2.5.txt	2012-02-03 12:47:10 +0000
+++ doc/en/release-notes/bzr-2.5.txt	2012-02-15 22:43:50 +0000
@@ -27,6 +27,9 @@
 .. Improvements to existing commands, especially improved performance 
    or memory usage, or better results.
 
+* The names of colocated branches are used as branch nicks if no nick is
+  specified. (Aaron Bentley)
+
 Bug Fixes
 *********
 

